from sys import argv
from pathlib import Path

name = input('Please enter funk name: ') if len(argv) < 2 else argv[1]

if not name:
  raise ValueError('Must supply a name for the funk.')

if name.endswith('.py'):
  name -= '.py'

path = './src/funks/' + f'{name}'.replace('.', '/') + '.py'

# Ensure directory exists before writing file
directory = path[:path.rfind('/')]
Path(directory).mkdir(parents=True, exist_ok=True)

with open(path, 'w') as φ:
  φ.writelines(
    '\n'.join([
      "from funki.funk import Funk",
      "",
      "# def _run(σ, x):",
      "#   # Reminders:",
      "#   # * write test first.",
      "#   # * σ: dict that holds state configured in setup method",
      "#   # * x: dict of input values",
      "#   pass",
      "",
      "funk = Funk(",
      f"  name='{name}',",
      f"  description='',",
      "  io_value_pairs=[",
      "    ({'x': ''},{'y': ''}),",
      "    (",
      "      {'x': ''},",
      "      {'y': ''}",
      "    )",
      "  ],",
      "  # run=_run",
      "  # run=lambda σ, x: None",
      ")",
    ])
  )
