from funki.refactor_recommender import RefactorRecommender

import importlib

def test():
  rr = RefactorRecommender()
  rr.get_list_of_python_files('./src/funks')

  funk_filenames = [_ for _ in rr.python_files]
  funk_filenames.sort()

  for funk_filename in funk_filenames:
    module = importlib.import_module(
      funk_filename.replace('/','.').replace('..','')[:-3]
    )

    if not module.funk.test():
      return False # Stop tests at first failure.
  return True # Reaching this point means all tests passed.
